#!/bin/bash
# $Header: /home/hiro/projects/dvr2/scripts/RCS/do-poll4ts.sh,v 1.3 2013/02/11 21:22:02 hiro Exp $
#
# poll4ts.sh
#
#	== Project DVR2 ==
#
#	Script for polling for new TS files
#
#	Copyright (c) 2011 Hiro Sugawara
#
myname=`basename $0 .sh`
mydir=`dirname $0`
FUSER=/sbin/fuser

TS2AVI=$mydir/ts2avi.sh

TSFPAT='^\w+-\w+-.*\.ts$'
AVIDIR=/var/multimedia/video/recorded
TSDIR=/var/multimedia/video/spool

logit() {
	logger -p 6ga.info -t "$myname[$$]" $@
}

#
# Look for new TS files and pass them to processing scripts in background
#
logit "dvr2: looking for unprocessed TS files in $TSDIR"
for file in `ls $TSDIR`
do
	if echo $file | grep -qE $TSFPAT && ! $FUSER $TSDIR/$file >/dev/null 2>&1
	then
		#
		# Are we really done with recording?
		#
		FNCORE=`echo $file | sed 's|-.*$||'`
		FNCHNL=`echo $file | sed 's|^[^\-]*-||;s|-.*$||'`
		FNSECS=`echo $file | sed 's|^.*-||;s|\..*$||'`
		((hhmm=FNCORE%10000))
		datestr=`printf "%.8s %04d" $FNCORE $hhmm`
		utime=`date --date="$datestr" +%s`
		((utime+=$FNSECS+10))
		now=`date +%s`
		if [ $utime -lt $now ]
		then
			logit "dvr2: starting TS2AVI to decrypt $file"
			$TS2AVI -d $TSDIR/$file &
			sleep 5
		fi
	fi
done

logit "dvr2: looking for unprocesed TS files in $AVIDIR"
for file in `ls $AVIDIR`
do
	if echo $file | grep -qE $TSFPAT && ! $FUSER $AVIDIR/$file >/dev/null 2>&1
	then
		logit "dvr2: starting TS2AVI for $file"
		$TS2AVI $AVIDIR/$file &
		sleep 5
	fi
done

logit "dvr2: no more unprocesed TS files"
